'-----------------------------------------------------------------
' CCTools IC-Bus-Routinen fr C-Control Mikro
' CCTools 2004 (http://cctools.hs-control.de)
'-----------------------------------------------------------------
' Ansteuerungsbeispiel zum Temperatursensor DS1631
'-----------------------------------------------------------------
define SCL PORT[5] ' Pull-Up mit 4,7k bis 10k notwendig
define SDA PORT[6] ' Pull-Up mit 4,7k bis 10k notwendig


define i byte[1] 'temporres Byte
define data byte[2] 'Byte zur Datenbergabe zu/von IC-Bus-Routinen

define MSB byte[3]
define LSB byte[4]

define DS1631addr  &b10010000 'Schreibadresse
define DS1631addrR &b10010001 'Leseadresse

baud 9600

gosub i2c_stop ' "Initialisierung" des IC-Busses

data = DS1631addr
gosub i2c_start
data = &hAC
gosub i2c_write
data = &b1100
gosub i2c_write
gosub i2c_stop

data = DS1631addr
gosub i2c_start
data = &h51
gosub i2c_write
gosub i2c_stop

#loop
 data = DS1631addr
 gosub i2c_start
 data = &hAA
 gosub i2c_write
 data = DS1631addrR
 gosub i2c_start
 gosub i2c_read
 MSB = data
 gosub i2c_readlast
 LSB = data
 gosub i2c_stop
 
 put 12
 if not(MSB and &h80) then goto posnum
  put &h2D
  LSB= 100-((LSB shr 4)*13)/2
  MSB=(127- (MSB and &h7F)) + (LSB/100)
  goto endif
 #posnum
  put &h20
  LSB=((LSB shr 4)*13)/2
 #endif
 print MSB;",";LSB;"C"

 pause 10
goto loop

'---------------------------------------
'IC-Bus-Routinen
'---------------------------------------
'---------------------------------------
#i2c_stop
'---------------------------------------
 SDA = 0
 DEACT SCL
 DEACT SDA
return

'---------------------------------------
#i2c_start 'returns Ack in i
'---------------------------------------
 SDA = 1
 SCL = 1
 SDA = 0
 SCL = 0
'---------------------------------------
#i2c_write 'returns Ack in i
'---------------------------------------
 SDA = data AND &h80
 TOG SCL
 TOG SCL
 for i=1 to 7
  SDA = data AND (&h80 SHR i)
  TOG SCL
  TOG SCL
 next
 DEACT SDA
 TOG SCL
 i = NOT SDA
 TOG SCL
return

'---------------------------------------
#i2c_read 'returns Databyte in data
'---------------------------------------
 gosub i2c_sub_read
 SDA = 0
 TOG SCL
 TOG SCL
return

'---------------------------------------
#i2c_readlast 'returns Databyte in data
'---------------------------------------
 gosub i2c_sub_read
 TOG SCL
 TOG SCL
return

#i2c_sub_read
 DEACT SDA
 data = 0
 for i=0 to 7
  TOG SCL
  data = (data shl 1) or (SDA and 1)
  TOG SCL
 next
return

